package nl.amis.test.hrm.service;
import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;
import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import nl.amis.hrm.dao.EmployeeDao;
import nl.amis.hrm.domain.Employee;
import nl.amis.hrm.service.HrmService;
import nl.amis.hrm.service.HrmServiceImpl;
import org.easymock.MockControl;

public class HrmServiceTester extends TestCase  {
  public HrmServiceTester(String sTestName) {
    super(sTestName);
  }

  private Float firstSalary = new Float("5000.15");
  protected HrmServiceImpl hrmServiceImpl0;

  private Collection getMockEmployees() {
    Collection employees = new Vector();
     MockControl employee1Control = MockControl.createControl(Employee.class);
     Employee employee1 = (Employee)employee1Control.getMock();
     employee1.getSalary();
     employee1Control.setReturnValue(firstSalary);
     employee1.getLastName();
     employee1Control.setReturnValue("Smith");   
     employee1Control.replay();
     employees.add(employee1);


     MockControl employee2Control = MockControl.createControl(Employee.class);
     Employee employee2 = (Employee)employee2Control.getMock();
     employee2.getSalary();
     employee2Control.setReturnValue(new Float("3000.12"));   
     employee2.getLastName();
     employee2Control.setReturnValue("Doe");   
     
     employee2Control.replay();
     employees.add(employee2);
     return employees;
  }

  private Collection getEmployees() {
  
    Collection employees = new Vector();
    
    employees.add(new Employee( "John Doe", new Float(1200.12),"Account Manager"));
    firstSalary = new Float("1200.12");
    employees.add(new Employee("Jane Doe", new Float(5200.87),"Account Manager"));
    employees.add(new Employee("Charlotte O'Neill", new Float(6200.31),"Manager"));
    employees.add(new Employee("Charles Brianson", new Float(8990.50),"Manager"));
    employees.add(new Employee("Jason King", new Float(6000.88),"Clerk"));
    return employees;
  }    

  /**
   * Collection getAllEmployees()
   */
  public void testgetAllEmployees() {
     // create a mock-control for the EmployeeDao interface of which we currently do not have an implementation to feed into the HrmService
     MockControl employeeDaoControl = MockControl.createControl(EmployeeDao.class);
     EmployeeDao employeeDao = (EmployeeDao)employeeDaoControl.getMock();
   
     Collection mockEmployees = getEmployees();
     employeeDao.getAllEmployees();
     employeeDaoControl.setReturnValue(mockEmployees);
     employeeDaoControl.replay();
     
     HrmServiceImpl hrmService = new HrmServiceImpl();
     hrmService.setEmployeeDao(employeeDao);
     
     Collection employees = hrmService.getAllEmployees();
     
     assertEquals("Collection with mockEmployees.size() elements should be returned", mockEmployees.size() ,employees.size());
     assertEquals("First Employee should have a salary of "+firstSalary, firstSalary ,((Employee)employees.iterator().next()).getSalary());
     Iterator iter= employees.iterator();
     iter.next();
     assertEquals("Second Employee should be called Jane Doe", "Jane Doe" ,((Employee)iter.next()).getLastName());
     
  }

  /**
   * void raiseAllSalaries(float)
   */
  public void testraiseAllSalaries() {
  
  // it is virtually impossible to test this when the EmployeeDao return mock Employees;

  }

  /**
   * void promoteToNewJob(Employee, String)
   */
  public void testpromoteToNewJob() {
  }
}